diff --git a/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/BobberNetEntry.java
similarity index 70%
rename from src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/BobberNetEntry.java
index 7ed14118a..51ba03a60 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/BobberNetEntry.java
@@ -2,6 +2,7 @@ package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.FishingBobberEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.AddEntityPacket;
@@ -10,7 +11,7 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class BobberEntry implements IVehicleEntry<FishingBobberEntity>, ITrackedEntry<FishingBobberEntity> {
+public class BobberNetEntry implements IVehicleEntry<FishingBobberEntity>, ITrackedEntry<FishingBobberEntity> {
     @Override
     public @NotNull Class<FishingBobberEntity> getAppliedClass() {
         return FishingBobberEntity.class;
@@ -38,11 +39,16 @@ public class BobberEntry implements IVehicleEntry<FishingBobberEntity>, ITracked
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new FishingBobberEntity(world, x, y, z);
+        FishingBobberEntity bobber = new FishingBobberEntity(world, x, y, z);
+        if (owner != null) {
+            bobber.owner = (Player) owner;
+            ((Player) owner).bobberEntity = bobber;
+        }
+        return bobber;
     }
 
     @Override
-    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, FishingBobberEntity trackedObject) {
-        return new AddEntityPacket(trackedObject);
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, FishingBobberEntity bobber) {
+        return new AddEntityPacket(bobber, 0, bobber.owner == null ? -1 : bobber.owner.id);
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 6257ec3c7..e2f6065d4 100644
--- a/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world;
 import net.minecraft.core.block.BedBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
+import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.entity.monster.SkeletonMob;
@@ -22,11 +23,24 @@ import net.minecraft.core.world.pathfinder.Node;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
 
+import java.util.Collection;
+import java.util.HashMap;
 import java.util.HashSet;
 import java.util.List;
+import java.util.Locale;
+import java.util.Map;
 import java.util.Set;
 public final class SpawnerMobs
 {
+    private static final Set<ChunkCoordinate> eligibleChunksForSpawning = new HashSet<>();
+    private static final Class<?>[] nightSpawnEntities;
+
+    static
+    {
+        nightSpawnEntities = new Class[] {
+            SpiderMob.class, ZombieMob.class, SkeletonMob.class, ZombieArmoredMob.class
+        };
+    }
 
     public SpawnerMobs()
     {
@@ -40,9 +54,9 @@ public final class SpawnerMobs
         return new ChunkPosition(newX, newY, newZ);
     }
 
-    public static int performSpawning(World world, boolean spawnHostileMobs, boolean spawnPassiveMobs)
+    public static int performSpawning(World world, SpawnerConfig spawnerConfig)
     {
-        if(!spawnHostileMobs && !spawnPassiveMobs) { return 0; }
+        if(!spawnerConfig.canHostileSpawn(world) && !spawnerConfig.canPassiveSpawn(world)) { return 0; }
         eligibleChunksForSpawning.clear();
 
         for (Player player : world.players){
@@ -71,8 +85,8 @@ public final class SpawnerMobs
 
         for (MobCategory creatureType : MobCategory.values()) {
 
-            if (creatureType.isPeaceful() && !spawnPassiveMobs) continue;
-            if (!creatureType.isPeaceful() && !spawnHostileMobs) continue;
+            if (creatureType.isPeaceful() && !spawnerConfig.canPassiveSpawn(world)) continue;
+            if (!creatureType.isPeaceful() && !spawnerConfig.canHostileSpawn(world)) continue;
             if (world.countEntities(creatureType.getBaseClass()) > ((creatureType.getMaxCreaturesPerChunk() * eligibleChunksForSpawning.size()) / 256))
                 continue;
 
@@ -111,6 +125,8 @@ public final class SpawnerMobs
                     }
                 }
 
+                if (!spawnerConfig.canMobSpawn(EntityDispatcher.getEncodeId(spawnListEntry.entityClass))) continue;
+
                 final ChunkPosition pos = getRandomSpawningPointInChunk(world, chunk.x, chunk.z);
                 final int x = pos.x;
                 final int y = pos.y;
@@ -291,14 +307,38 @@ public final class SpawnerMobs
 		}
 		return spawnedEntity;
 	}
+    public static class SpawnerConfig {
+        private boolean allowPassive = true;
+        private boolean allowHostile = true;
+        private final Map<String, Boolean> mobSpawnOverrides = new HashMap<>();
 
-    private static final Set<ChunkCoordinate> eligibleChunksForSpawning = new HashSet<>();
-    private static final Class<?>[] nightSpawnEntities;
+        public boolean canPassiveSpawn(World world) {
+            return allowPassive;
+        }
 
-    static 
-    {
-        nightSpawnEntities = new Class[] {
-            SpiderMob.class, ZombieMob.class, SkeletonMob.class, ZombieArmoredMob.class
-        };
+        public void setPassiveSpawning(boolean flag) {
+            allowPassive = flag;
+        }
+
+        public boolean canHostileSpawn(World world) {
+            return allowHostile && world.difficultySetting > 0;
+        }
+
+        public void setHostileSpawning(boolean flag) {
+            allowHostile = flag;
+        }
+
+        public boolean canMobSpawn(String mobID) {
+            return mobSpawnOverrides.getOrDefault(mobID.toLowerCase(Locale.ROOT), true);
+        }
+
+        public void setMobSpawn(String mobID, boolean flag) {
+            mobSpawnOverrides.put(mobID.toLowerCase(Locale.ROOT), flag);
+        }
+
+        public Collection<Map.Entry<String, Boolean>> getSpawnEntries() {
+            return mobSpawnOverrides.entrySet();
+        }
     }
+
 }
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 858c08536..29ae30407 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -105,7 +105,7 @@ public class World implements WorldSource {
     public final Dimension dimension;
     public final WorldType worldType;
     protected IChunkProvider chunkProvider;
-    protected final LevelStorage saveHandler;
+    public final LevelStorage saveHandler;
     protected LevelData levelData;
     public DimensionData dimensionData;
     public boolean findingSpawnPoint;
@@ -113,8 +113,7 @@ public class World implements WorldSource {
     public SavedDataStorage savedDataStorage;
     private boolean field_31055_L;
     private int lightingUpdatesCounter = 0;
-    protected boolean spawnHostileMobs = true;
-    private boolean spawnPeacefulMobs = true;
+    public final SpawnerMobs.SpawnerConfig spawningConfig;
     static int lightingUpdatesScheduled = 0;
     private int caveSoundCounter = rand.nextInt(12000);
     public boolean isClientSide = false;
@@ -131,11 +130,12 @@ public class World implements WorldSource {
     public final WeatherManager weatherManager;
 
     //Usually called when a world is loaded or generated (Singleplayer & Server)
-    public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType)
+    public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType, SpawnerMobs.SpawnerConfig spawningConfig)
     {
         this.saveHandler = saveHandler;
         this.savedDataStorage = new SavedDataStorage(saveHandler);
         this.levelData = saveHandler.getLevelData();
+        this.spawningConfig = spawningConfig;
         this.isNewWorld = levelData == null;
 
         // Attempt to determine the correct dimension for this world
@@ -224,6 +224,7 @@ public class World implements WorldSource {
         saveHandler = world.saveHandler;
 
         levelData = new LevelData(world.levelData);
+        this.spawningConfig = world.spawningConfig;
 
         dimensionData = world.saveHandler.getDimensionData(dimension.id);
         if (dimensionData == null)
@@ -276,6 +277,8 @@ public class World implements WorldSource {
         auroraProvider = new AuroraProvider(this, seed);
 
         biomeProvider = this.worldType.createBiomeProvider(this);
+
+        spawningConfig = new SpawnerMobs.SpawnerConfig();
     }
     // Used for the model viewer
     public World(){
@@ -292,6 +295,8 @@ public class World implements WorldSource {
         auroraProvider = new AuroraProvider(this, 0);
 
         biomeProvider = this.worldType.createBiomeProvider(this);
+
+        spawningConfig = new SpawnerMobs.SpawnerConfig();
     }
 
     public <T> T getGameRuleValue(GameRule<T> gameRule)
@@ -2457,10 +2462,10 @@ public class World implements WorldSource {
         }
     }
 
-    public void setAllowedMobSpawns(boolean flag, boolean flag1)
+    public void setAllowedMobSpawns(boolean spawnHostile, boolean spawnPassive)
     {
-        spawnHostileMobs = flag;
-        spawnPeacefulMobs = flag1;
+        spawningConfig.setPassiveSpawning(spawnPassive);
+        spawningConfig.setHostileSpawning(spawnHostile);
     }
 
     public void allChanged(boolean lightChanged, boolean seasonChanged) {
@@ -2474,7 +2479,7 @@ public class World implements WorldSource {
         if(areEnoughPlayersFullyAsleep())
         {
             boolean wasInterrupted = false;
-            if(spawnHostileMobs && difficultySetting >= 1 && getPlayersRequiredToSkipNight() <= 1)
+            if(spawningConfig.canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1)
             {
                 wasInterrupted = SpawnerMobs.performSleepSpawning(this, players);
             }
@@ -2497,7 +2502,7 @@ public class World implements WorldSource {
 		updateSleepingPlayers();
         Debug.change("spawning");
         // TODO mob spawning seems to be the cause of many lag spikes, specifically the checks for is a mob is allowed to spawn at a certain xyz position seem to be the worst offenders
-		SpawnerMobs.performSpawning(this, spawnHostileMobs, spawnPeacefulMobs);
+		SpawnerMobs.performSpawning(this, spawningConfig);
         Debug.change("chunk");
 		chunkProvider.tick();
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index f18e68706..d2b82cd93 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -152,6 +152,11 @@ public class ChunkLoaderLegacy
         }
     }
 
+    @Override
+    public boolean isSaving() {
+        return false;
+    }
+
     public static void storeChunkInCompound(Chunk chunk, World world, CompoundTag tag)
     {
         world.checkSessionLock();
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
index af5823a5b..0e4f16d97 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
@@ -71,4 +71,9 @@ public class ChunkLoaderRegion
             exception.printStackTrace();
         }
     }
+
+    @Override
+    public boolean isSaving() {
+        return false;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
index f9d2c0c9a..a3654058e 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
@@ -60,6 +60,11 @@ public class ChunkLoaderRegionAsync
         }
     }
 
+    @Override
+    public boolean isSaving() {
+        return !chunksToSave.isEmpty();
+    }
+
     private static class ChunkSaveThread extends Thread
     {
         public volatile boolean shouldStop = false;
diff --git a/src/main/java/net/minecraft/core/world/chunk/IChunkLoader.java b/src/main/java/net/minecraft/core/world/chunk/IChunkLoader.java
index 241ee52f0..8c258a408 100644
--- a/src/main/java/net/minecraft/core/world/chunk/IChunkLoader.java
+++ b/src/main/java/net/minecraft/core/world/chunk/IChunkLoader.java
@@ -29,4 +29,10 @@ public interface IChunkLoader
      */
     void saveChunk(World world, Chunk chunk)
         throws IOException;
+
+
+    /**
+     * @return true if busy saving
+     */
+    boolean isSaving();
 }
diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/src/main/java/net/minecraft/server/MinecraftServer.java
index 684464006..3a4b91f02 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -25,6 +25,7 @@ import net.minecraft.core.util.helper.RestHandler;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -109,7 +110,8 @@ public class MinecraftServer
         propertyManager = new PropertyManager(new File("server.properties"));
         String s = propertyManager.getStringProperty("server-ip", "");
         onlineMode = propertyManager.getBooleanProperty("online-mode", true);
-        spawnPeacefulMobs = propertyManager.getBooleanProperty("spawn-animals", true);
+        spawnerConfig.setPassiveSpawning(propertyManager.getBooleanProperty("spawn-animals", true));
+        spawnerConfig.setHostileSpawning(propertyManager.getBooleanProperty("spawn-monsters", true));
         pvpOn = propertyManager.getBooleanProperty("pvp", true);
         allowFlight = propertyManager.getBooleanProperty("allow-flight", false);
         statsToken = propertyManager.getStringProperty("stats-token", "only-enter-a-value-if-you-are-a-registered-server");
@@ -346,16 +348,15 @@ public class MinecraftServer
         {
             if (i == 0)
             {
-                dimensionWorlds[i] = new WorldServer(this, saveHandler, worldDirName, i, defaultWorldType, l);
+                dimensionWorlds[i] = new WorldServer(this, saveHandler, worldDirName, i, defaultWorldType, l, spawnerConfig);
             }
             else
             {
-                dimensionWorlds[i] = new WorldServerMulti(this, saveHandler, worldDirName, i, Dimension.getDimensionList().get(i).defaultWorldType, l, dimensionWorlds[0]);
+                dimensionWorlds[i] = new WorldServerMulti(this, saveHandler, worldDirName, i, Dimension.getDimensionList().get(i).defaultWorldType, l, dimensionWorlds[0], spawnerConfig);
             }
             dimensionWorlds[i].addListener(new WorldManager(this, dimensionWorlds[i]));
             dimensionWorlds[i].difficultySetting = difficulty;
             dimensionWorlds[i].sleepPercent = sleepPercentage;
-            dimensionWorlds[i].setAllowedMobSpawns(propertyManager.getBooleanProperty("spawn-monsters", true), spawnPeacefulMobs);
             playerList.setPlayerManager(dimensionWorlds);
         }
 
@@ -794,5 +795,6 @@ public class MinecraftServer
     public int autoSaveInterval = 5;
     public int chunksSavedPerAutosave = 24;
     public boolean forceSaveAllChunksOnAutosave = false;
+    public SpawnerMobs.SpawnerConfig spawnerConfig = new SpawnerMobs.SpawnerConfig();
 
 }
diff --git a/src/main/java/net/minecraft/server/world/WorldServer.java b/src/main/java/net/minecraft/server/world/WorldServer.java
index d691573ab..b0b9c8a24 100644
--- a/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -32,9 +32,9 @@ import net.minecraft.server.MinecraftServer;
 public class WorldServer extends World
 {
 
-    public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed)
+    public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed, SpawnerMobs.SpawnerConfig spawnerConfig)
     {
-        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType);
+        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType, spawnerConfig);
         field_819_z = false;
         entityIntHashMap = new IntHashMap<>();
         mcServer = minecraftserver;
@@ -114,7 +114,7 @@ public class WorldServer extends World
         if(areEnoughPlayersFullyAsleep())
         {
             boolean wasInterrupted = false;
-            if(spawnHostileMobs && difficultySetting >= 1 && getPlayersRequiredToSkipNight() <= 1)
+            if(spawningConfig.canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1)
             {
                 wasInterrupted = SpawnerMobs.performSleepSpawning(this, players);
             }
diff --git a/src/main/java/net/minecraft/server/world/WorldServerMulti.java b/src/main/java/net/minecraft/server/world/WorldServerMulti.java
index b9228f383..a0b3d1e7b 100644
--- a/src/main/java/net/minecraft/server/world/WorldServerMulti.java
+++ b/src/main/java/net/minecraft/server/world/WorldServerMulti.java
@@ -1,5 +1,6 @@
 package net.minecraft.server.world;
 
+import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.world.save.LevelStorage;
@@ -10,9 +11,9 @@ import net.minecraft.core.world.save.LevelStorage;
 public class WorldServerMulti extends WorldServer
 {
 
-    public WorldServerMulti(MinecraftServer minecraftserver, LevelStorage isavehandler, String s, int dimensionId, WorldType worldType, long l, WorldServer worldserver)
+    public WorldServerMulti(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed, WorldServer worldserver, SpawnerMobs.SpawnerConfig spawnerConfig)
     {
-        super(minecraftserver, isavehandler, s, dimensionId, worldType, l);
+        super(minecraftserver, isavehandler, name, dimensionId, worldType, seed, spawnerConfig);
         savedDataStorage = worldserver.savedDataStorage;
     }
 }
